# -*- coding: utf-8 -*- 

# https://github.com/Hnfull/Intensio-Obfuscator

#--------------------------------------------------------- [Global] ---------------------------------------------------------#

# Only replace string to string feature [-rts, --replacetostr]

EXCLUDE_WORDS_BY_DEFAULT = [
                            # keywords
                            "as",
                            "assert",
                            "break",
                            "class",
                            "continue",
                            "def",
                            "del",
                            "elif",
                            "else",
                            "except",
                            "False",
                            "finally",
                            "for",
                            "from",
                            "global",
                            "if",
                            "import",
                            "in",
                            "is",
                            "lambda",
                            "None",
                            "nonlocal",
                            "not",
                            "or",
                            "pass",
                            "raise",
                            "return",
                            "True",
                            "try",
                            "while",
                            "with",
                            "yield",
                            
                            # string methods
                            "capitalize",
                            "casefold",
                            "encode",
                            "endswith",
                            "expandtabs",
                            "format",
                            "format_map",
                            "isalnum",
                            "isalpha",
                            "isdecimal",
                            "isdigit",
                            "isidentifier",
                            "islower",
                            "isnumeric",
                            "isprintable",
                            "isspace",
                            "istitle",
                            "isupper",
                            "join",
                            "ljust",
                            "lower",
                            "maketrans",
                            "partition",
                            "replace",
                            "rfind",
                            "rindex",
                            "rjust",
                            "rpartition",
                            "rsplit",
                            "rstrip",
                            "split",
                            "splitlines",
                            "startswith",
                            "strip",
                            "swapcase",
                            "title",
                            "translate",

                            # built in functions
                            "abs",
                            "all",
                            "any",
                            "ascii",
                            "bin",
                            "bool",
                            "bytearray",
                            "bytes",
                            "callable",
                            "chr",
                            "classmethod",
                            "compile",
                            "complex",
                            "delattr",
                            "dict",
                            "dir",
                            "divmod",
                            "enumerate",
                            "eval",
                            "exec",
                            "filter",
                            "float",
                            "format",
                            "frozenset",
                            "getattr",
                            "globals",
                            "hasattr",
                            "hash",
                            "help",
                            "hex",
                            "id",
                            "input",
                            "int",
                            "isinstance",
                            "issubclass",
                            "iter",
                            "len",
                            "list",
                            "locals",
                            "map",
                            "max",
                            "memoryview",
                            "min",
                            "next",
                            "object",
                            "oct",
                            "open",
                            "ord",
                            "pow",
                            "print",
                            "property",
                            "range",
                            "repr",
                            "reversed",
                            "round",
                            "set",
                            "setattr",
                            "slice",
                            "sorted",
                            "@staticmethod",
                            "str",
                            "sum",
                            "super",
                            "tuple",
                            "type",
                            "vars",
                            "zip",

                            # list methods
                            "append",
                            "clear",
                            "copy",
                            "count",
                            "extend",
                            "index",
                            "insert",
                            "pop",
                            "remove",
                            "reverse",
                            "sort",

                            # dict methods
                            "clear",
                            "copy",
                            "fromkeys",
                            "get",
                            "items",
                            "keys",
                            "pop",
                            "popitem",
                            "setdefault",
                            "update",
                            "values",

                            # tuple methods
                            "count",
                            "index",

                            # set methods
                            "add",
                            "clear",
                            "copy",
                            "difference",
                            "difference_update",
                            "discard",
                            "intersection",
                            "intersection_update",
                            "isdisjoint",
                            "issubset",
                            "issuperset",
                            "pop",
                            "remove",
                            "symmetric_difference",
                            "symmetric_difference_update",
                            "union",
                            "update",

                            # file methods
                            "close",
                            "detach",
                            "fileno",
                            "flush",
                            "isatty",
                            "read",
                            "readable",
                            "readline",
                            "readlines",
                            "seek",
                            "seekable",
                            "tell",
                            "truncate",
                            "write",
                            "writeable",
                            "writelines",
                            
                            # types
                            "b",
                            "r",
                            "u",
                            "f",

                            # special
                            "_",
                            "__",
                            "__abs__",
                            "__add__",
                            "__aenter__",
                            "__aexit__",
                            "__aiter__",
                            "__all__",
                            "__and__",
                            "__anext__",
                            "__annotations__ ",
                            "__await__",
                            "__bases__",
                            "__bool__",
                            "__breakpointhook__",
                            "__bytes__",
                            "__cached__",
                            "__call__",
                            "__callback__",
                            "__cause__",
                            "__ceil__",
                            "__class__",
                            "__class_getitem__",
                            "__classcell__",
                            "__closure__",
                            "__code__",
                            "__complex__",
                            "__concat__",
                            "__contains__",
                            "__context__",
                            "__copy__",
                            "__debug__",
                            "__deepcopy__",
                            "__defaults__",
                            "__del__",
                            "__delattr__",
                            "__delete__",
                            "__delitem__",
                            "__dict__",
                            "__dir__",
                            "__dir__",
                            "__displayhook__",
                            "__divmod__",
                            "__doc__",
                            "__enter__",
                            "__eq__",
                            "__excepthook__",
                            "__exit__",
                            "__file__",
                            "__float__",
                            "__floor__",
                            "__floordiv__",
                            "__format__",
                            "__format__",
                            "__fspath__",
                            "__func__",
                            "__future__",
                            "__future__",
                            "__ge__",
                            "__get__tr__",
                            "__getattribute__",
                            "__getitem__",
                            "__getnewargs__",
                            "__getnewargs_ex__",
                            "__getstate__",
                            "__gt__",
                            "__hash__",
                            "__iadd__",
                            "__iand__",
                            "__iconcat__",
                            "__ifloordiv__",
                            "__ilshift__",
                            "__imatmul__",
                            "__imod__",
                            "__import__",
                            "__imul__",
                            "__index__",
                            "__init__",
                            "__init_subclass__",
                            "__instancecheck__",
                            "__int__",
                            "__invert__",
                            "__ior__",
                            "__ipow__",
                            "__irshift__",
                            "__isub__",
                            "__iter__",
                            "__itruediv__",
                            "__ixor__",
                            "__le__",
                            "__len__",
                            "__length_hint__",
                            "__loader__",
                            "__lshift__",
                            "__lt__",
                            "__main__",
                            "__matmul__",
                            "__missing__",
                            "__mod__",
                            "__mul__",
                            "__name__",
                            "__ne__",
                            "__neg__",
                            "__new__",
                            "__next__",
                            "__not__",
                            "__or__",
                            "__package__",
                            "__path__",
                            "__pos__",
                            "__pow__",
                            "__prepare__",
                            "__qualname__",
                            "__radd__",
                            "__rand__",
                            "__rdivmod__",
                            "__reduce__",
                            "__reduce_ex__",
                            "__repr__",
                            "__reversed__",
                            "__rfloordiv__",
                            "__rlshift__",
                            "__rmatmul__",
                            "__rmod__",
                            "__rmul__",
                            "__ror__",
                            "__round__",
                            "__rpow__",
                            "__rrshift__",
                            "__rshift__",
                            "__rsub__",
                            "__rtruediv__",
                            "__rxor__",
                            "__self__",
                            "__set__",
                            "__set_name__",
                            "__setattr__",
                            "__setitem__",
                            "__setstate__",
                            "__slots__",
                            "__spec__",
                            "__stderr__",
                            "__stdin__",
                            "__stdout__",
                            "__str__",
                            "__sub__",
                            "__subclasscheck__",
                            "__subclasses__",
                            "__subclasshook__",
                            "__suppress_context__",
                            "__traceback__",
                            "__truediv__",
                            "__trunc__",
                            "__xor__",
                            "_anonymous_",
                            "_asdict",
                            "_b_base_",
                            "_b_needsfree_",
                            "_callmethod",
                            "_CData",
                            "_clear_type_cache",
                            "_current_frames",
                            "_debugmallocstats",
                            "_dummy_thread",
                            "_enablelegacywindowsfsencoding",
                            "_exit",
                            "_field_defaults",
                            "_fields",
                            "_fields_",
                            "_flush",
                            "_frozen",
                            "_FuncPtr",
                            "_get_child_mock",
                            "_getframe",
                            "_getvalue",
                            "_handle",
                            "_inittab",
                            "_length_",
                            "_locale",
                            "_make",
                            "_makeResult",
                            "_name",
                            "_objects",
                            "_pack_",
                            "_parse",
                            "_Pointer ",
                            "_Py_c_diff",
                            "_Py_c_neg",
                            "_Py_c_pow",
                            "_Py_c_prod",
                            "_Py_c_quot",
                            "_Py_c_sum",
                            "_Py_NoneStruct",
                            "_PyBytes_Resize",
                            "_PyCFunctionFast",
                            "_PyCFunctionFastWithKeywords",
                            "_PyImport_Fini",
                            "_PyImport_Init",
                            "_PyObject_GC_TRACK",
                            "_PyObject_GC_UNTRACK",
                            "_PyObject_New",
                            "_PyObject_NewVar",
                            "_PyTuple_Resize",
                            "_replace",
                            "_setroot",
                            "_SimpleCData",
                            "_structure",
                            "_thread",
                            "_thread",
                            "_type_",
                            "_write",
                            "_xoptions"
]
